rm(list=ls())
if (!require("openxlsx")){install.packages("openxlsx");library(openxlsx)}else{library(openxlsx)}
if (!require("ggplot2")){install.packages("ggplot2");library(ggplot2)}else{library(ggplot2)}
if (!require("gridExtra")){install.packages("gridExtra");library(gridExtra)}else{library(gridExtra)}
if (!require("leaflet")){install.packages("leaflet");library(leaflet)}else{library(leaflet)}
if (!require("scales")){install.packages("scales");library(scales)}else{library(scales)}
if (!require("ggsci")){install.packages("ggsci");library(ggsci)}else{library(ggsci)}
if (!require("lubridate")){install.packages("lubridate");library(lubridate)}else{library(lubridate)}
if (!require("geosphere")){install.packages("geosphere");library(geosphere)}else{library(geosphere)}
if (!require("ROI")){install.packages("ROI");library(ROI)}else{library(ROI)}
if (!require("ROI.plugin.glpk")){install.packages("ROI.plugin.glpk");library(ROI.plugin.glpk)}else{library(ROI.plugin.glpk)}

fechas <- as.POSIXct(read.xlsx("DATASET.xlsx", sheet = "Capacidad")[,1]*86400, 
                     origin="1899-12-30",tz="GMT")
dias_mes <- days_in_month(fechas)
fechas_diario <- seq(from=fechas[1], length.out = sum(dias_mes), by = "days")

### Unión de nodos 
# Ballena: 1:8,63
# Barranca: 9:15
# Sebastopol: 16
# Vasconia: 17,18
# Mariquita: 19:23
# Pereira: 24,25
# Armenia: 26,27
# Cali: 28,29
# Gualanday: 32
# Neiva: 36
# La Belleza: 37
# Cogua: 39
# El Porvenir: 40:42
# Cusiana: 46:48
# Apiay: 49,50
# TermOcoa: 51,52
# Bogotá: 55:57
# Medellín: 58,59
# Bucaramanga: 60
# Gibraltar: 61,62
# La Mami: 64
# Barranquilla: 65:67
# Cartagena: 68
# Sincelejo: 69
# Jobo: 70,71
# La Creciente: 72,73

asignaciones <- list(c(1:8,63),9:15,16,17:18,19:23,24:25,26:27,28:29,32,
                     36,37,39,40:42,46:48,49:50,51:52,55:57,
                     58:59,60,61:62,64,65:67,68,69,70:71,c(72,73))

#### Ingreso y Gráfica de Nodos y Gasoductos ####
data_nodos <- read.xlsx("DATASET.xlsx", sheet = "CoordenadasNodos")
num_nod <- length(data_nodos$NODO)

tuberias <- read.xlsx("DATASET.xlsx", sheet = "NoNulas")
subtramos <- read.xlsx("DATASET.xlsx", sheet = "SUBCoordenadas")

split_sub <- split(subtramos,subtramos$TRAMO)
loops <- list(); verificador <- list(); contador <- 1

for(tramo in 1:length(tuberias$Gasoducto)) {
  if(is.element(tuberias$Gasoducto[tramo],subtramos$TRAMO)) {
    i <- 1; mientras <- TRUE; temp <- list()
    while(mientras) {
      if(tuberias$Gasoducto[tramo]==split_sub[[i]]$TRAMO[1]) {
        temp <- split_sub[[i]]
        mientras <- FALSE
      } else {
        i <- i+1
      }
    }
    if(tramo==1) {
      loops[[contador]] <- data.frame(tramos=c(tuberias$Gasoducto[tramo]),
                                      lon=c(data_nodos$Longitud[tuberias$i[tramo]],temp$Longitud,
                                            data_nodos$Longitud[tuberias$j[tramo]]),
                                      lat=c(data_nodos$Latitud[tuberias$i[tramo]],temp$Latitud,
                                            data_nodos$Latitud[tuberias$j[tramo]]))
      verificador[[contador]] <- c(tuberias$i[tramo],tuberias$j[tramo])
      contador <- contador + 1 
    } else {
      tub_Incluida <- FALSE
      for(revision in 1:length(verificador)) {
        #Se verifica si la tubería ya se incluyó para no repetir tramos.
        if(sum(c(tuberias$i[tramo],tuberias$j[tramo])==verificador[[revision]])==2||
           sum(c(tuberias$j[tramo],tuberias$i[tramo])==verificador[[revision]])==2) {
          tub_Incluida <- TRUE
        }
      }
      if(!tub_Incluida) {
        loops[[contador]] <- data.frame(tramos=c(tuberias$Gasoducto[tramo]),
                                        lon=c(data_nodos$Longitud[tuberias$i[tramo]],temp$Longitud,
                                              data_nodos$Longitud[tuberias$j[tramo]]),
                                        lat=c(data_nodos$Latitud[tuberias$i[tramo]],temp$Latitud,
                                              data_nodos$Latitud[tuberias$j[tramo]]))
        verificador[[contador]] <- c(tuberias$i[tramo],tuberias$j[tramo])
        contador <- contador + 1 
      }
    }
  } else {
    if(tramo==1) {
      loops[[contador]] <- data.frame(tramos=c(tuberias$Gasoducto[tramo]),
                                      lon=c(data_nodos$Longitud[tuberias$i[tramo]],data_nodos$Longitud[tuberias$j[tramo]]),
                                      lat=c(data_nodos$Latitud[tuberias$i[tramo]],data_nodos$Latitud[tuberias$j[tramo]]))
      verificador[[contador]] <- c(tuberias$i[tramo],tuberias$j[tramo])
      contador <- contador + 1 
    } else {
      tub_Incluida <- FALSE
      for(revision in 1:length(verificador)) {
        #Se verifica si la tubería ya se incluyó para no repetir tramos.
        if(sum(c(tuberias$i[tramo],tuberias$j[tramo])==verificador[[revision]])==2||
           sum(c(tuberias$j[tramo],tuberias$i[tramo])==verificador[[revision]])==2) {
          tub_Incluida <- TRUE
        }
      }
      if(!tub_Incluida) {
        loops[[contador]] <- data.frame(tramos=c(tuberias$Gasoducto[tramo]),
                                        lon=c(data_nodos$Longitud[tuberias$i[tramo]],data_nodos$Longitud[tuberias$j[tramo]]),
                                        lat=c(data_nodos$Latitud[tuberias$i[tramo]],data_nodos$Latitud[tuberias$j[tramo]]))
        verificador[[contador]] <- c(tuberias$i[tramo],tuberias$j[tramo])
        contador <- contador + 1 
      }
    }
  }
}

loops_verificador <- list(loops=loops,verificador=verificador)

library(purrr)
#---Create Vector----
nodo_graph<-data_nodos[-21,]
ob_Facility <- nodo_graph %>% 
  split(., .$Nombre)
#---Create Map----
mapa_tuberias <- leaflet(options = leafletOptions(zoomControl = FALSE)) %>% 
  setView(lng = -74.25, lat = 7.25, zoom = 6) %>% #setting the view over Colombia (Magdalena Medio)
  addProviderTiles(providers$Esri.WorldGrayCanvas)

for(i in 1:length(loops)) {
  mapa_tuberias <- addPolylines(mapa_tuberias,data = loops[[i]], lng = ~ lon, lat = ~ lat, popup = ~ tramos, 
                                label = ~ tramos, labelOptions = labelOptions(textsize = "32px"), color = "black", 
                                weight = 2, fillOpacity = 0.75) 
}

#---Purrr Layers----
names(ob_Facility) %>%
  purrr::walk(function(nodo_graph) {
    mapa_tuberias <<- mapa_tuberias %>%
      addCircles(data=ob_Facility[[nodo_graph]],lat = ~ Latitud, lng = ~ Longitud, weight = 1,
                 radius = 7500, fillOpacity = 0.75, label = ~Nombre,
                 labelOptions = labelOptions(noHide = T, textOnly = TRUE,textsize = "10px",direction = ~MyDirections,
                                             offset = c(~offset_x,~offset_y)))
  })

mapa_tuberias

#### Ingreso de Producción en Nodos ####
# Máxima Capacidad de Producción (MBTUD)
produccionT <- read.xlsx("DATASET.xlsx", sheet = "ProduccionNodos(CI)_KPCD")[1:76,]
produccion <- cbind(data_nodos[,1:2],matrix(rep(0,num_nod*12),
                                            nrow=num_nod,ncol=12))
for(i in 1:num_nod){
  if(i<21){
    suma<-as.numeric(colSums(produccionT[asignaciones[[i]],c(4:15)]))
  } else if(i>21){
    suma<-as.numeric(colSums(produccionT[asignaciones[[(i-1)]],c(4:15)]))
  } else {
    suma<-0
  }
  produccion[i,3:14]<-suma
}

#### Producción registrada
# produccion <- read.xlsx("DATASET.xlsx", sheet = "ProduccionNodos_TOTAL")

#### Ingreso de Demanda en Nodos ####
DemandaNodos <- read.xlsx("DATASET.xlsx", sheet = "DemandaNodos_TOTAL")

#### Ingreso de Capacidad de Tuberías ####
CapacidadTub <- read.xlsx("DATASET.xlsx", sheet = "Capacidad")

#### Ingreso de Precio en boca de pozo (Promedio ponderado TOTAL?) ####
PrecioNodos <- read.xlsx("DATASET.xlsx", sheet = "PrecioNodos(USD-KPC)")

#### Ingreso de Tarifa de transporte en boca de pozo ####
TarifasTransporte <- read.xlsx("DATASET.xlsx", sheet = "TarifasTransporte")

#### Prueba sin gas contratado ni costo por gas no contratado - Linear Programming ####
#2021
tot_meses <- 6
tot_dias <- length(fechas_diario[1:184])
indices_Cap <- tuberias

cap_diaria <- matrix(rep(0,tot_dias*length(indices_Cap[,1])),
                     nrow=tot_dias,ncol=length(indices_Cap[,1]))
for(i in 1:length(indices_Cap[,1])) {
  capacidad_tub <- CapacidadTub[,which(indices_Cap$Capacidad[i]==names(CapacidadTub))]
  cap_temp <- c()
  for(j in 1:tot_meses) {
    cap_temp <- c(cap_temp,rep(capacidad_tub[j],dias_mes[j]))
  }
  cap_diaria[,i] <- as.numeric(cap_temp)
}

###Se crea matriz de tarifas de transporte
TarifasNodos<-matrix(rep(0,num_nod*num_nod),nrow=num_nod,ncol=num_nod)
splitMat<-split(tuberias,tuberias$Capacidad)
for(j in 1:length(splitMat)){
  whichGz<-which(TarifasTransporte$Gasoducto==splitMat[[j]]$Capacidad[1])
  #Para estamp 2: +TarifasTransporte[[4]]
  tariff<-(TarifasTransporte[[2]])[whichGz]
  for(i in 1:length(tariff)){
    TarifasNodos[splitMat[[j]]$i[i],splitMat[[j]]$j[i]]<-tariff[i]
  }
}
heatmap(TarifasNodos, Colv = NA, Rowv = NA)

# Energía equivalente al volumen transportado desde el nodo i al nodo j (MBTU-dia)
QT_ij <- list()
for(i in 1:tot_dias) {
  QT_ij[[i]] <- matrix(rep(0,num_nod*num_nod),nrow=num_nod,ncol=num_nod)
}

# Energía equivalente al volumen producido en el nodo j (MBTU-dia)
QS_j <- list()
for(i in 1:tot_dias) {
  QS_j[[i]] <- rep(0,num_nod)
}

### Matriz de capacidades máximas de tramos de tubería (KPC-dia)
Q_MAX <- QT_ij
for(t in 1:tot_dias) {
  for(k in 1:length(indices_Cap[,1])) {
    Q_MAX[[t]][indices_Cap$i[k],indices_Cap$j[k]] <- cap_diaria[,k][t]
  }
}

###### Generador de condiciones y restricciones
### BALANCE
qiniS_j <- list()
qiniT <- list()

for(j in 1:num_nod) {
  qSt <- rep(0,num_nod)
  qSt[j] <- 1
  qiniS_j[[j]] <- qSt
  qTt_ij <- matrix(rep(0,num_nod*num_nod),nrow=num_nod,ncol=num_nod)
  qTt_ji <- matrix(rep(0,num_nod*num_nod),nrow=num_nod,ncol=num_nod)
  for(i in 1:num_nod) {
    qTt_ij[i,j] <- 1
    qTt_ji[j,i] <- 1
  }
  qiniT[[j]] <- qTt_ij - qTt_ji
}

c_demand <- c()
for(i in 1:num_nod) {
  c_demand <- c(c_demand,qiniS_j[[i]]) #El primer qiniS_j[[i]] agrega la producción
  for(j in 1:num_nod) {
    c_demand <- c(c_demand,qiniT[[i]][,j])
  }
}

prod_diaria <- matrix(rep(0,num_nod*tot_dias),nrow=num_nod,ncol=tot_dias)
demanda_diaria <- data.matrix(DemandaNodos[,-c(1,2)])
precio_diaria <- data.matrix(PrecioNodos[,-c(1,2)])
for(i in 1:num_nod) {
  prod_temp <- c()
  for(j in 1:tot_meses) {
    prod_temp <- c(prod_temp,rep(produccion[i,][2+j],dias_mes[j]))
  }
  prod_diaria[i,] <- as.numeric(prod_temp)
}

objval <- rep(0,tot_dias)
for(i in 1:tot_dias) {
  precios <- precio_diaria[,i]
  transporte <- c()
  for(j in 1:num_nod) {
    transporte <- c(transporte,TarifasNodos[,j])
  }
  
  ### FUNCIÓN DE BALANCE
  dem <- demanda_diaria[,i]
  
  cap_trans <- c()
  for(j in 1:num_nod) {
    cap_trans <- c(cap_trans,Q_MAX[[i]][,j])
  }
  
  prod_lim <- prod_diaria[,i]
  b <- ROI::V_bound(ub = c(prod_lim,cap_trans))
  op <- ROI::OP(objective = c(precios,transporte), bounds = b, 
                ROI::L_constraint(L = matrix(c_demand,nrow=num_nod,byrow=T), rep("==",num_nod), dem))
  
  res <- ROI::ROI_solve(op, solver = "glpk")
  
  objval[i] <- res$objval
  QS_j[[i]] <- round(ROI::solution(res)[1:num_nod],digits=1)
  for(j in 1:num_nod) {
    for(k in 1:num_nod) {
      QT_ij[[i]][k,j] <- round(ROI::solution(res)[num_nod+(j-1)*num_nod+k],digits=1)
    }
  }
}

qs_list <- list()
for(i in 1:num_nod) {
  temp <- c()
  for(j in 1:tot_dias) {
    temp[j] <- QS_j[[j]][i]
  }
  qs_list[[i]] <- temp
}

qt_list <- list()
for(i in 1:num_nod) {
  temp_out <- list()
  for(j in 1:num_nod) {
    temp_int <- c()
    for(k in 1:tot_dias) {
      temp_int[k] <- QT_ij[[k]][i,j]
    }
    temp_out[[j]] <- temp_int
  }
  qt_list[[i]] <- temp_out
}

data_cost<-data.frame(fecha=fechas_diario[1:184],cost=objval)
disc<-2000000
min<-disc*floor(min(data_cost$cost)/disc)
max<-disc*ceiling(max(data_cost$cost)/disc)
ggplot(data_cost, aes(x=fecha, y=cost)) + geom_line(aes(y=cost),color='black') + 
  scale_fill_npg() + labs(x = "Fecha", y = "Costo [USD]") + 
  scale_x_datetime(labels = date_format("%Y/%m"), breaks = date_breaks("months"), expand = c(0.035,0.1)) +
  scale_y_continuous(expand = c(0.01,0.001),breaks = seq(min, max, by = disc), 
                     limits=c(min,max),label=comma) + 
  theme_bw() + theme(text = element_text(size=12),legend.title=element_blank(),legend.position="bottom")

volumenes_sim<-tuberias
volumenes_sim<-cbind(volumenes_sim,matrix(rep(0,tot_dias*length(volumenes_sim[,1])),
                                          nrow=length(volumenes_sim[,1]),ncol=tot_dias))
costo_trans<-volumenes_sim

for(k in 1:length(volumenes_sim[,1])){
  i<-volumenes_sim$i[k]
  j<-volumenes_sim$j[k]
  volumenes_sim[k,-c(1:4)]<-qt_list[[i]][[j]]
}

for(k in 1:length(costo_trans[,1])){
  i<-costo_trans$i[k]
  j<-costo_trans$j[k]
  costo_trans[k,-c(1:4)]<-TarifasNodos[i,j]*volumenes_sim[k,-c(1:4)]
}

q_prod<-matrix(unlist(qs_list), nrow=length(qs_list), byrow=TRUE)
cost_prod<-precio_diaria[,1:184]*q_prod

dataset_names <- list("Volúmenes Transportados" = volumenes_sim, 
                      "Costo Transporte (USD)" = costo_trans,
                      "Volumen Producido" = q_prod,
                      "Costo Molecula" = cost_prod)
write.xlsx(dataset_names, file = "TOTAL_2021.xlsx")



#2022
tot_meses <- 6
tot_dias <- length(fechas_diario[185:365])
indices_Cap <- tuberias

cap_diaria <- matrix(rep(0,tot_dias*length(indices_Cap[,1])),
                     nrow=tot_dias,ncol=length(indices_Cap[,1]))
for(i in 1:length(indices_Cap[,1])) {
  capacidad_tub <- CapacidadTub[,which(indices_Cap$Capacidad[i]==names(CapacidadTub))]
  cap_temp <- c()
  for(j in 7:(6+tot_meses)) {
    cap_temp <- c(cap_temp,rep(capacidad_tub[j],dias_mes[j]))
  }
  cap_diaria[,i] <- as.numeric(cap_temp)
}

###Se crea matriz de tarifas de transporte
TarifasNodos<-matrix(rep(0,num_nod*num_nod),nrow=num_nod,ncol=num_nod)
splitMat<-split(tuberias,tuberias$Capacidad)
for(j in 1:length(splitMat)){
  whichGz<-which(TarifasTransporte$Gasoducto==splitMat[[j]]$Capacidad[1])
  #Para estamp 2: +TarifasTransporte[[4]]
  tariff<-(TarifasTransporte[[3]])[whichGz]
  for(i in 1:length(tariff)){
    TarifasNodos[splitMat[[j]]$i[i],splitMat[[j]]$j[i]]<-tariff[i]
  }
}
heatmap(TarifasNodos, Colv = NA, Rowv = NA)

# Energía equivalente al volumen transportado desde el nodo i al nodo j (MBTU-dia)
QT_ij <- list()
for(i in 1:tot_dias) {
  QT_ij[[i]] <- matrix(rep(0,num_nod*num_nod),nrow=num_nod,ncol=num_nod)
}

# Energía equivalente al volumen producido en el nodo j (MBTU-dia)
QS_j <- list()
for(i in 1:tot_dias) {
  QS_j[[i]] <- rep(0,num_nod)
}

### Matriz de capacidades máximas de tramos de tubería (KPC-dia)
Q_MAX <- QT_ij
for(t in 1:tot_dias) {
  for(k in 1:length(indices_Cap[,1])) {
    Q_MAX[[t]][indices_Cap$i[k],indices_Cap$j[k]] <- cap_diaria[,k][t]
  }
}

###### Generador de condiciones y restricciones
### BALANCE
qiniS_j <- list()
qiniT <- list()

for(j in 1:num_nod) {
  qSt <- rep(0,num_nod)
  qSt[j] <- 1
  qiniS_j[[j]] <- qSt
  qTt_ij <- matrix(rep(0,num_nod*num_nod),nrow=num_nod,ncol=num_nod)
  qTt_ji <- matrix(rep(0,num_nod*num_nod),nrow=num_nod,ncol=num_nod)
  for(i in 1:num_nod) {
    qTt_ij[i,j] <- 1
    qTt_ji[j,i] <- 1
  }
  qiniT[[j]] <- qTt_ij - qTt_ji
}

c_demand <- c()
for(i in 1:num_nod) {
  c_demand <- c(c_demand,qiniS_j[[i]]) #El primer qiniS_j[[i]] agrega la producción
  for(j in 1:num_nod) {
    c_demand <- c(c_demand,qiniT[[i]][,j])
  }
}

prod_diaria <- matrix(rep(0,num_nod*tot_dias),nrow=num_nod,ncol=tot_dias)
demanda_diaria <- data.matrix(DemandaNodos[,(187:367)])
precio_diaria <- data.matrix(PrecioNodos[,(187:367)])
for(i in 1:num_nod) {
  prod_temp <- c()
  for(j in 7:(6+tot_meses)) {
    prod_temp <- c(prod_temp,rep(produccion[i,][2+j],dias_mes[j]))
  }
  prod_diaria[i,] <- as.numeric(prod_temp)
}

objval <- rep(0,tot_dias)
for(i in 1:tot_dias) {
  precios <- precio_diaria[,i]
  transporte <- c()
  for(j in 1:num_nod) {
    transporte <- c(transporte,TarifasNodos[,j])
  }
  
  ### FUNCIÓN DE BALANCE
  dem <- demanda_diaria[,i]
  
  cap_trans <- c()
  for(j in 1:num_nod) {
    cap_trans <- c(cap_trans,Q_MAX[[i]][,j])
  }
  
  prod_lim <- prod_diaria[,i]
  b <- ROI::V_bound(ub = c(prod_lim,cap_trans))
  op <- ROI::OP(objective = c(precios,transporte), bounds = b, 
                ROI::L_constraint(L = matrix(c_demand,nrow=num_nod,byrow=T), rep("==",num_nod), dem))
  
  res <- ROI::ROI_solve(op, solver = "glpk")
  
  objval[i] <- res$objval
  QS_j[[i]] <- round(ROI::solution(res)[1:num_nod],digits=1)
  for(j in 1:num_nod) {
    for(k in 1:num_nod) {
      QT_ij[[i]][k,j] <- round(ROI::solution(res)[num_nod+(j-1)*num_nod+k],digits=1)
    }
  }
}

qs_list <- list()
for(i in 1:num_nod) {
  temp <- c()
  for(j in 1:tot_dias) {
    temp[j] <- QS_j[[j]][i]
  }
  qs_list[[i]] <- temp
}

qt_list <- list()
for(i in 1:num_nod) {
  temp_out <- list()
  for(j in 1:num_nod) {
    temp_int <- c()
    for(k in 1:tot_dias) {
      temp_int[k] <- QT_ij[[k]][i,j]
    }
    temp_out[[j]] <- temp_int
  }
  qt_list[[i]] <- temp_out
}

data_cost<-data.frame(fecha=fechas_diario[185:365],cost=objval)
disc<-2000000
min<-disc*floor(min(data_cost$cost)/disc)
max<-disc*ceiling(max(data_cost$cost)/disc)
ggplot(data_cost, aes(x=fecha, y=cost)) + geom_line(aes(y=cost),color='black') + 
  scale_fill_npg() + labs(x = "Fecha", y = "Costo [USD]") + 
  scale_x_datetime(labels = date_format("%Y/%m"), breaks = date_breaks("months"), expand = c(0.035,0.1)) +
  scale_y_continuous(expand = c(0.01,0.001),breaks = seq(min, max, by = disc), 
                     limits=c(min,max),label=comma) + 
  theme_bw() + theme(text = element_text(size=12),legend.title=element_blank(),legend.position="bottom")

volumenes_sim<-tuberias
volumenes_sim<-cbind(volumenes_sim,matrix(rep(0,tot_dias*length(volumenes_sim[,1])),
                                          nrow=length(volumenes_sim[,1]),ncol=tot_dias))
costo_trans<-volumenes_sim

for(k in 1:length(volumenes_sim[,1])){
  i<-volumenes_sim$i[k]
  j<-volumenes_sim$j[k]
  volumenes_sim[k,-c(1:4)]<-qt_list[[i]][[j]]
}

for(k in 1:length(costo_trans[,1])){
  i<-costo_trans$i[k]
  j<-costo_trans$j[k]
  costo_trans[k,-c(1:4)]<-TarifasNodos[i,j]*volumenes_sim[k,-c(1:4)]
}

q_prod<-matrix(unlist(qs_list), nrow=length(qs_list), byrow=TRUE)
cost_prod<-precio_diaria*q_prod

dataset_names <- list("Volúmenes Transportados" = volumenes_sim, 
                      "Costo Transporte (USD)" = costo_trans,
                      "Volumen Producido" = q_prod,
                      "Costo Molecula" = cost_prod)
write.xlsx(dataset_names, file = "TOTAL_2022.xlsx")

#SISTEMA ÓPTIMO
CostoM_2021 <- read.xlsx("TOTAL_2021.xlsx",sheet="Costo Molecula")
CostoM_2022 <- read.xlsx("TOTAL_2022.xlsx",sheet="Costo Molecula")
VP_2021 <- read.xlsx("TOTAL_2021.xlsx",sheet="Volumen Producido")
VP_2022 <- read.xlsx("TOTAL_2022.xlsx",sheet="Volumen Producido")
VT_2021 <- read.xlsx("TOTAL_2021.xlsx",sheet="Volúmenes Transportados")
VT_2022 <- read.xlsx("TOTAL_2022.xlsx",sheet="Volúmenes Transportados")

#COSTO MOLÉCULA
CB_B_2021 <- as.numeric(VT_2021[1,-c(1:4)])*as.numeric(PrecioNodos[1,c(3:(184+2))])
CB_B_2022 <- as.numeric(VT_2022[1,-c(1:4)])*as.numeric(PrecioNodos[1,-c(1:(184+2))])
CostoM_Interior <- sum(CostoM_2021[2:20,])+sum(CostoM_2022[2:20,])+sum(CB_B_2021)+sum(CB_B_2022)
CostoM_Costa <- sum(CostoM_2021[-c(2:20),])+sum(CostoM_2022[-c(2:20),])-sum(CB_B_2021)-sum(CB_B_2022)
CostoM_Sistema <- round(CostoM_Interior,1)+round(CostoM_Costa,1)-1

Reporte_Actual <- read.xlsx("../SISTEMA_ACTUAL/REPORTE.xlsx")
100*(CostoM_Sistema-Reporte_Actual$Valor[10])/Reporte_Actual$Valor[10]

REPORTE<-data.frame(Nombre=c("Costo de molécula (bajo agregación de tramos) - Sistema [$USD]",
                             "Diferencia de costo de molécula para el SNT [%]"),
                    Valor=c(CostoM_Sistema,round(100*(CostoM_Sistema-Reporte_Actual$Valor[12])/Reporte_Actual$Valor[12],2)
                    ))
write.xlsx(REPORTE, file = "REPORTE.xlsx")
CostoM_Sistema