rm(list=ls())
if (!require("openxlsx")){install.packages("openxlsx");library(openxlsx)}else{library(openxlsx)}
if (!require("ggplot2")){install.packages("ggplot2");library(ggplot2)}else{library(ggplot2)}
if (!require("gridExtra")){install.packages("gridExtra");library(gridExtra)}else{library(gridExtra)}
if (!require("leaflet")){install.packages("leaflet");library(leaflet)}else{library(leaflet)}
if (!require("scales")){install.packages("scales");library(scales)}else{library(scales)}
if (!require("ggsci")){install.packages("ggsci");library(ggsci)}else{library(ggsci)}
if (!require("lubridate")){install.packages("lubridate");library(lubridate)}else{library(lubridate)}
if (!require("geosphere")){install.packages("geosphere");library(geosphere)}else{library(geosphere)}
if (!require("ROI")){install.packages("ROI");library(ROI)}else{library(ROI)}
if (!require("ROI.plugin.glpk")){install.packages("ROI.plugin.glpk");library(ROI.plugin.glpk)}else{library(ROI.plugin.glpk)}

fechas <- as.POSIXct(read.xlsx("DATASET.xlsx", sheet = "Capacidad")[,1]*86400, 
                     origin="1899-12-30",tz="GMT")
dias_mes <- days_in_month(fechas)
fechas_diario <- seq(from=fechas[1], length.out = sum(dias_mes), by = "days")

#### Ingreso y Gráfica de Nodos y Gasoductos ####
data_nodos <- read.xlsx("DATASET.xlsx", sheet = "CoordenadasNodos")
num_nod <- length(data_nodos$NODO)

tuberias <- read.xlsx("DATASET.xlsx", sheet = "NoNulas")
subtramos <- read.xlsx("DATASET.xlsx", sheet = "SUBCoordenadas")

split_sub <- split(subtramos,subtramos$TRAMO)
loops <- list(); verificador <- list(); contador <- 1

for(tramo in 1:length(tuberias$Gasoducto)) {
  if(is.element(tuberias$Gasoducto[tramo],subtramos$TRAMO)) {
    i <- 1; mientras <- TRUE; temp <- list()
    while(mientras) {
      if(tuberias$Gasoducto[tramo]==split_sub[[i]]$TRAMO[1]) {
        temp <- split_sub[[i]]
        mientras <- FALSE
      } else {
        i <- i+1
      }
    }
    if(tramo==1) {
      loops[[contador]] <- data.frame(tramos=c(tuberias$Gasoducto[tramo]),
                                      lon=c(data_nodos$Longitud[tuberias$i[tramo]],temp$Longitud,
                                            data_nodos$Longitud[tuberias$j[tramo]]),
                                      lat=c(data_nodos$Latitud[tuberias$i[tramo]],temp$Latitud,
                                            data_nodos$Latitud[tuberias$j[tramo]]))
      verificador[[contador]] <- c(tuberias$i[tramo],tuberias$j[tramo])
      contador <- contador + 1 
    } else {
      tub_Incluida <- FALSE
      for(revision in 1:length(verificador)) {
        #Se verifica si la tubería ya se incluyó para no repetir tramos.
        if(sum(c(tuberias$i[tramo],tuberias$j[tramo])==verificador[[revision]])==2||
           sum(c(tuberias$j[tramo],tuberias$i[tramo])==verificador[[revision]])==2) {
          tub_Incluida <- TRUE
        }
      }
      if(!tub_Incluida) {
        loops[[contador]] <- data.frame(tramos=c(tuberias$Gasoducto[tramo]),
                                        lon=c(data_nodos$Longitud[tuberias$i[tramo]],temp$Longitud,
                                              data_nodos$Longitud[tuberias$j[tramo]]),
                                        lat=c(data_nodos$Latitud[tuberias$i[tramo]],temp$Latitud,
                                              data_nodos$Latitud[tuberias$j[tramo]]))
        verificador[[contador]] <- c(tuberias$i[tramo],tuberias$j[tramo])
        contador <- contador + 1 
      }
    }
  } else {
    if(tramo==1) {
      loops[[contador]] <- data.frame(tramos=c(tuberias$Gasoducto[tramo]),
                                      lon=c(data_nodos$Longitud[tuberias$i[tramo]],data_nodos$Longitud[tuberias$j[tramo]]),
                                      lat=c(data_nodos$Latitud[tuberias$i[tramo]],data_nodos$Latitud[tuberias$j[tramo]]))
      verificador[[contador]] <- c(tuberias$i[tramo],tuberias$j[tramo])
      contador <- contador + 1 
    } else {
      tub_Incluida <- FALSE
      for(revision in 1:length(verificador)) {
        #Se verifica si la tubería ya se incluyó para no repetir tramos.
        if(sum(c(tuberias$i[tramo],tuberias$j[tramo])==verificador[[revision]])==2||
           sum(c(tuberias$j[tramo],tuberias$i[tramo])==verificador[[revision]])==2) {
          tub_Incluida <- TRUE
        }
      }
      if(!tub_Incluida) {
        loops[[contador]] <- data.frame(tramos=c(tuberias$Gasoducto[tramo]),
                                        lon=c(data_nodos$Longitud[tuberias$i[tramo]],data_nodos$Longitud[tuberias$j[tramo]]),
                                        lat=c(data_nodos$Latitud[tuberias$i[tramo]],data_nodos$Latitud[tuberias$j[tramo]]))
        verificador[[contador]] <- c(tuberias$i[tramo],tuberias$j[tramo])
        contador <- contador + 1 
      }
    }
  }
}

loops_verificador <- list(loops=loops,verificador=verificador)

library(purrr)
#---Create Vector----
nodo_graph<-data_nodos[-21,]
ob_Facility <- nodo_graph %>% 
  split(., .$Nombre)
#---Create Map----
mapa_tuberias <- leaflet(options = leafletOptions(zoomControl = FALSE)) %>% 
  setView(lng = -74.25, lat = 7.25, zoom = 6) %>% #setting the view over Colombia (Magdalena Medio)
  addProviderTiles(providers$Esri.WorldGrayCanvas)

for(i in 1:length(loops)) {
  mapa_tuberias <- addPolylines(mapa_tuberias,data = loops[[i]], lng = ~ lon, lat = ~ lat, popup = ~ tramos, 
                                label = ~ tramos, labelOptions = labelOptions(textsize = "32px"), color = "black", 
                                weight = 2, fillOpacity = 0.75) 
}

#---Purrr Layers----
names(ob_Facility) %>%
  purrr::walk(function(nodo_graph) {
    mapa_tuberias <<- mapa_tuberias %>%
      addCircles(data=ob_Facility[[nodo_graph]],lat = ~ Latitud, lng = ~ Longitud, weight = 1,
                 radius = 7500, fillOpacity = 0.75, label = ~Nombre,
                 labelOptions = labelOptions(noHide = T, textOnly = TRUE,textsize = "10px",direction = ~MyDirections,
                                             offset = c(~offset_x,~offset_y)))
  })

mapa_tuberias

#### Producción registrada
produccion <- read.xlsx("DATASET.xlsx", sheet = "ProduccionNodos_TOTAL")

#### Ingreso de Demanda en Nodos ####
DemandaNodos <- read.xlsx("DATASET.xlsx", sheet = "DemandaNodos_TOTAL")

#### Ingreso de Capacidad de Tuberías ####
CapacidadTub <- read.xlsx("DATASET.xlsx", sheet = "Capacidad")

#### Ingreso de Precio en boca de pozo (Promedio ponderado TOTAL?) ####
PrecioNodos <- read.xlsx("DATASET.xlsx", sheet = "PrecioNodos(USD-KPC)")

#### Ingreso de Tarifa de transporte en boca de pozo ####
TarifasTransporte <- read.xlsx("DATASET.xlsx", sheet = "TarifasTransporte")

#### Prueba sin gas contratado ni costo por gas no contratado - Linear Programming ####
#2021
tot_meses <- 6
tot_dias <- length(fechas_diario[1:184])
indices_Cap <- tuberias

cap_diaria <- matrix(rep(0,tot_dias*length(indices_Cap[,1])),
                     nrow=tot_dias,ncol=length(indices_Cap[,1]))
for(i in 1:length(indices_Cap[,1])) {
  capacidad_tub <- CapacidadTub[,which(indices_Cap$Capacidad[i]==names(CapacidadTub))]
  cap_temp <- c()
  for(j in 1:tot_meses) {
    cap_temp <- c(cap_temp,rep(capacidad_tub[j],dias_mes[j]))
  }
  cap_diaria[,i] <- as.numeric(cap_temp)
}

###Se crea matriz de tarifas de transporte
TarifasNodos<-matrix(rep(0,num_nod*num_nod),nrow=num_nod,ncol=num_nod)
splitMat<-split(tuberias,tuberias$Capacidad)
for(j in 1:length(splitMat)){
  whichGz<-which(TarifasTransporte$Gasoducto==splitMat[[j]]$Capacidad[1])
  #Para estamp 2: +TarifasTransporte[[4]]
  tariff<-(TarifasTransporte[[2]])[whichGz]
  for(i in 1:length(tariff)){
    TarifasNodos[splitMat[[j]]$i[i],splitMat[[j]]$j[i]]<-tariff[i]
  }
}
heatmap(TarifasNodos, Colv = NA, Rowv = NA)

# Energía equivalente al volumen transportado desde el nodo i al nodo j (MBTU-dia)
QT_ij <- list()
for(i in 1:tot_dias) {
  QT_ij[[i]] <- matrix(rep(0,num_nod*num_nod),nrow=num_nod,ncol=num_nod)
}

# Energía equivalente al volumen producido en el nodo j (MBTU-dia)
QS_j <- list()
for(i in 1:tot_dias) {
  QS_j[[i]] <- rep(0,num_nod)
}

### Matriz de capacidades máximas de tramos de tubería (KPC-dia)
Q_MAX <- QT_ij
for(t in 1:tot_dias) {
  for(k in 1:length(indices_Cap[,1])) {
    Q_MAX[[t]][indices_Cap$i[k],indices_Cap$j[k]] <- cap_diaria[,k][t]
  }
}

###### Generador de condiciones y restricciones
### BALANCE
qiniS_j <- list()
qiniT <- list()

for(j in 1:num_nod) {
  qSt <- rep(0,num_nod)
  qSt[j] <- 1
  qiniS_j[[j]] <- qSt
  qTt_ij <- matrix(rep(0,num_nod*num_nod),nrow=num_nod,ncol=num_nod)
  qTt_ji <- matrix(rep(0,num_nod*num_nod),nrow=num_nod,ncol=num_nod)
  for(i in 1:num_nod) {
    qTt_ij[i,j] <- 1
    qTt_ji[j,i] <- 1
  }
  qiniT[[j]] <- qTt_ij - qTt_ji
}

c_demand <- c()
for(i in 1:num_nod) {
  c_demand <- c(c_demand,qiniS_j[[i]]) #El primer qiniS_j[[i]] agrega la producción
  for(j in 1:num_nod) {
    c_demand <- c(c_demand,qiniT[[i]][,j])
  }
}

prod_diaria <- data.matrix(produccion[,-c(1,2)])
demanda_diaria <- data.matrix(DemandaNodos[,-c(1,2)])
precio_diaria <- data.matrix(PrecioNodos[,-c(1,2)])

objval <- rep(0,tot_dias)
for(i in 1:tot_dias) {
  precios <- precio_diaria[,i]
  transporte <- c()
  for(j in 1:num_nod) {
    transporte <- c(transporte,TarifasNodos[,j])
  }
  
  ### FUNCIÓN DE BALANCE
  dem <- demanda_diaria[,i]
  
  cap_trans <- c()
  for(j in 1:num_nod) {
    cap_trans <- c(cap_trans,Q_MAX[[i]][,j])
  }
  
  prod_lim <- prod_diaria[,i]
  b <- ROI::V_bound(ub = c(prod_lim,cap_trans))
  op <- ROI::OP(objective = c(precios,transporte), bounds = b, 
                ROI::L_constraint(L = matrix(c_demand,nrow=num_nod,byrow=T), rep("==",num_nod), dem))
  
  res <- ROI::ROI_solve(op, solver = "glpk")
  
  objval[i] <- res$objval
  QS_j[[i]] <- round(ROI::solution(res)[1:num_nod],digits=1)
  for(j in 1:num_nod) {
    for(k in 1:num_nod) {
      QT_ij[[i]][k,j] <- round(ROI::solution(res)[num_nod+(j-1)*num_nod+k],digits=1)
    }
  }
}

qs_list <- list()
for(i in 1:num_nod) {
  temp <- c()
  for(j in 1:tot_dias) {
    temp[j] <- QS_j[[j]][i]
  }
  qs_list[[i]] <- temp
}

qt_list <- list()
for(i in 1:num_nod) {
  temp_out <- list()
  for(j in 1:num_nod) {
    temp_int <- c()
    for(k in 1:tot_dias) {
      temp_int[k] <- QT_ij[[k]][i,j]
    }
    temp_out[[j]] <- temp_int
  }
  qt_list[[i]] <- temp_out
}

data_cost<-data.frame(fecha=fechas_diario[1:184],cost=objval)
disc<-2000000
min<-disc*floor(min(data_cost$cost)/disc)
max<-disc*ceiling(max(data_cost$cost)/disc)
ggplot(data_cost, aes(x=fecha, y=cost)) + geom_line(aes(y=cost),color='black') + 
  scale_fill_npg() + labs(x = "Fecha", y = "Costo [USD]") + 
  scale_x_datetime(labels = date_format("%Y/%m"), breaks = date_breaks("months"), expand = c(0.035,0.1)) +
  scale_y_continuous(expand = c(0.01,0.001),breaks = seq(min, max, by = disc), 
                     limits=c(min,max),label=comma) + 
  theme_bw() + theme(text = element_text(size=12),legend.title=element_blank(),legend.position="bottom")

volumenes_sim<-tuberias
volumenes_sim<-cbind(volumenes_sim,matrix(rep(0,tot_dias*length(volumenes_sim[,1])),
                                          nrow=length(volumenes_sim[,1]),ncol=tot_dias))
costo_trans<-volumenes_sim

for(k in 1:length(volumenes_sim[,1])){
  i<-volumenes_sim$i[k]
  j<-volumenes_sim$j[k]
  volumenes_sim[k,-c(1:4)]<-qt_list[[i]][[j]]
}

for(k in 1:length(costo_trans[,1])){
  i<-costo_trans$i[k]
  j<-costo_trans$j[k]
  costo_trans[k,-c(1:4)]<-TarifasNodos[i,j]*volumenes_sim[k,-c(1:4)]
}

colSums(costo_trans[,-c(1:4)])

q_prod<-matrix(unlist(qs_list), nrow=length(qs_list), byrow=TRUE)
cost_prod<-precio_diaria[,1:184]*q_prod

dataset_names <- list("Volúmenes Transportados" = volumenes_sim, 
                      "Costo Transporte (USD)" = costo_trans,
                      "Volumen Producido" = q_prod,
                      "Costo Molecula" = cost_prod)
write.xlsx(dataset_names, file = "TOTAL_2021_H.xlsx")



#2022
tot_meses <- 6
tot_dias <- length(fechas_diario[185:365])
indices_Cap <- tuberias

cap_diaria <- matrix(rep(0,tot_dias*length(indices_Cap[,1])),
                     nrow=tot_dias,ncol=length(indices_Cap[,1]))
for(i in 1:length(indices_Cap[,1])) {
  capacidad_tub <- CapacidadTub[,which(indices_Cap$Capacidad[i]==names(CapacidadTub))]
  cap_temp <- c()
  for(j in 7:(6+tot_meses)) {
    cap_temp <- c(cap_temp,rep(capacidad_tub[j],dias_mes[j]))
  }
  cap_diaria[,i] <- as.numeric(cap_temp)
}

###Se crea matriz de tarifas de transporte
TarifasNodos<-matrix(rep(0,num_nod*num_nod),nrow=num_nod,ncol=num_nod)
splitMat<-split(tuberias,tuberias$Capacidad)
for(j in 1:length(splitMat)){
  whichGz<-which(TarifasTransporte$Gasoducto==splitMat[[j]]$Capacidad[1])
  #Para estamp 2: +TarifasTransporte[[4]]
  tariff<-(TarifasTransporte[[3]])[whichGz]
  for(i in 1:length(tariff)){
    TarifasNodos[splitMat[[j]]$i[i],splitMat[[j]]$j[i]]<-tariff[i]
  }
}
heatmap(TarifasNodos, Colv = NA, Rowv = NA)

# Energía equivalente al volumen transportado desde el nodo i al nodo j (MBTU-dia)
QT_ij <- list()
for(i in 1:tot_dias) {
  QT_ij[[i]] <- matrix(rep(0,num_nod*num_nod),nrow=num_nod,ncol=num_nod)
}

# Energía equivalente al volumen producido en el nodo j (MBTU-dia)
QS_j <- list()
for(i in 1:tot_dias) {
  QS_j[[i]] <- rep(0,num_nod)
}

### Matriz de capacidades máximas de tramos de tubería (KPC-dia)
Q_MAX <- QT_ij
for(t in 1:tot_dias) {
  for(k in 1:length(indices_Cap[,1])) {
    Q_MAX[[t]][indices_Cap$i[k],indices_Cap$j[k]] <- cap_diaria[,k][t]
  }
}

###### Generador de condiciones y restricciones
### BALANCE
qiniS_j <- list()
qiniT <- list()

for(j in 1:num_nod) {
  qSt <- rep(0,num_nod)
  qSt[j] <- 1
  qiniS_j[[j]] <- qSt
  qTt_ij <- matrix(rep(0,num_nod*num_nod),nrow=num_nod,ncol=num_nod)
  qTt_ji <- matrix(rep(0,num_nod*num_nod),nrow=num_nod,ncol=num_nod)
  for(i in 1:num_nod) {
    qTt_ij[i,j] <- 1
    qTt_ji[j,i] <- 1
  }
  qiniT[[j]] <- qTt_ij - qTt_ji
}

c_demand <- c()
for(i in 1:num_nod) {
  c_demand <- c(c_demand,qiniS_j[[i]]) #El primer qiniS_j[[i]] agrega la producción
  for(j in 1:num_nod) {
    c_demand <- c(c_demand,qiniT[[i]][,j])
  }
}

prod_diaria <- data.matrix(produccion[,(187:367)])
demanda_diaria <- data.matrix(DemandaNodos[,(187:367)])
precio_diaria <- data.matrix(PrecioNodos[,(187:367)])

objval <- rep(0,tot_dias)
for(i in 1:tot_dias) {
  precios <- precio_diaria[,i]
  transporte <- c()
  for(j in 1:num_nod) {
    transporte <- c(transporte,TarifasNodos[,j])
  }
  
  ### FUNCIÓN DE BALANCE
  dem <- demanda_diaria[,i]
  
  cap_trans <- c()
  for(j in 1:num_nod) {
    cap_trans <- c(cap_trans,Q_MAX[[i]][,j])
  }
  
  prod_lim <- prod_diaria[,i]
  b <- ROI::V_bound(ub = c(prod_lim,cap_trans))
  op <- ROI::OP(objective = c(precios,transporte), bounds = b, 
                ROI::L_constraint(L = matrix(c_demand,nrow=num_nod,byrow=T), rep("==",num_nod), dem))
  
  res <- ROI::ROI_solve(op, solver = "glpk")
  
  objval[i] <- res$objval
  QS_j[[i]] <- round(ROI::solution(res)[1:num_nod],digits=1)
  for(j in 1:num_nod) {
    for(k in 1:num_nod) {
      QT_ij[[i]][k,j] <- round(ROI::solution(res)[num_nod+(j-1)*num_nod+k],digits=1)
    }
  }
}

qs_list <- list()
for(i in 1:num_nod) {
  temp <- c()
  for(j in 1:tot_dias) {
    temp[j] <- QS_j[[j]][i]
  }
  qs_list[[i]] <- temp
}

qt_list <- list()
for(i in 1:num_nod) {
  temp_out <- list()
  for(j in 1:num_nod) {
    temp_int <- c()
    for(k in 1:tot_dias) {
      temp_int[k] <- QT_ij[[k]][i,j]
    }
    temp_out[[j]] <- temp_int
  }
  qt_list[[i]] <- temp_out
}

data_cost<-data.frame(fecha=fechas_diario[185:365],cost=objval)
disc<-2000000
min<-disc*floor(min(data_cost$cost)/disc)
max<-disc*ceiling(max(data_cost$cost)/disc)
ggplot(data_cost, aes(x=fecha, y=cost)) + geom_line(aes(y=cost),color='black') + 
  scale_fill_npg() + labs(x = "Fecha", y = "Costo [USD]") + 
  scale_x_datetime(labels = date_format("%Y/%m"), breaks = date_breaks("months"), expand = c(0.035,0.1)) +
  scale_y_continuous(expand = c(0.01,0.001),breaks = seq(min, max, by = disc), 
                     limits=c(min,max),label=comma) + 
  theme_bw() + theme(text = element_text(size=12),legend.title=element_blank(),legend.position="bottom")

volumenes_sim<-tuberias
volumenes_sim<-cbind(volumenes_sim,matrix(rep(0,tot_dias*length(volumenes_sim[,1])),
                                          nrow=length(volumenes_sim[,1]),ncol=tot_dias))
costo_trans<-volumenes_sim

for(k in 1:length(volumenes_sim[,1])){
  i<-volumenes_sim$i[k]
  j<-volumenes_sim$j[k]
  volumenes_sim[k,-c(1:4)]<-qt_list[[i]][[j]]
}

for(k in 1:length(costo_trans[,1])){
  i<-costo_trans$i[k]
  j<-costo_trans$j[k]
  costo_trans[k,-c(1:4)]<-TarifasNodos[i,j]*volumenes_sim[k,-c(1:4)]
}

colSums(costo_trans[,-c(1:4)])

q_prod<-matrix(unlist(qs_list), nrow=length(qs_list), byrow=TRUE)
cost_prod<-precio_diaria*q_prod

dataset_names <- list("Volúmenes Transportados" = volumenes_sim, 
                      "Costo Transporte (USD)" = costo_trans,
                      "Volumen Producido" = q_prod,
                      "Costo Molecula" = cost_prod)
write.xlsx(dataset_names, file = "TOTAL_2022_H.xlsx")

#HISTÓRICO
COSTO_AOM <- read.xlsx("COSTO_ACTUAL_SISTEMA.xlsx",sheet="COSTO_AOM")
COSTO_VAR <- read.xlsx("COSTO_ACTUAL_SISTEMA.xlsx",sheet="COSTO_VAR")

#SISTEMA ÓPTIMO
CostoT_2021 <- read.xlsx("TOTAL_2021_H.xlsx",sheet="Costo Transporte (USD)")
CostoT_2022 <- read.xlsx("TOTAL_2022_H.xlsx",sheet="Costo Transporte (USD)")
CostoM_2021 <- read.xlsx("TOTAL_2021_H.xlsx",sheet="Costo Molecula")
CostoM_2022 <- read.xlsx("TOTAL_2022_H.xlsx",sheet="Costo Molecula")
VP_2021 <- read.xlsx("TOTAL_2021_H.xlsx",sheet="Volumen Producido")
VP_2022 <- read.xlsx("TOTAL_2022_H.xlsx",sheet="Volumen Producido")
VT_2021 <- read.xlsx("TOTAL_2021_H.xlsx",sheet="Volúmenes Transportados")
VT_2022 <- read.xlsx("TOTAL_2022_H.xlsx",sheet="Volúmenes Transportados")

#TRANSPORTE - INTERIOR (ÓPTIMO)
I_2021<-sum(CostoT_2021[1:27,-c(1:4)])
I_2022<-sum(CostoT_2022[1:27,-c(1:4)])
I_AOM <-sum(COSTO_AOM[,c(2:18,25:27)])
I_TOTAL <- I_2021+I_2022+I_AOM

#TRANSPORTE - PROMIGAS (ÓPTIMO)
P_2021<-sum(CostoT_2021[-c(1:27),-c(1:4)])
P_2022<-sum(CostoT_2022[-c(1:27),-c(1:4)])
P_AOM <-sum(COSTO_AOM[,c(19:24)])
P_TOTAL <- P_2021+P_2022+P_AOM

SISTEMA_TOTAL <- I_TOTAL+P_TOTAL

#ESTAMPILLA TRANSPORTE
ESTAMPILLA_INTERIOR<-I_TOTAL/(sum(VP_2021[2:20,])+sum(VP_2022[2:20,])+
                                sum(VT_2021[1,-c(1:4)])+sum(VT_2022[1,-c(1:4)]))
ESTAMPILLA_PROMIGAS<-P_TOTAL/(sum(VP_2021[-c(2:20),])+sum(VP_2022[-c(2:20),])-
                                sum(VT_2021[1,-c(1:4)])-sum(VT_2022[1,-c(1:4)]))
ESTAMPILLA_SISTEMA<-(SISTEMA_TOTAL)/(sum(VP_2021)+sum(VP_2022))

#COSTO HISTÓRICO
I_TOTAL_H <- sum(COSTO_VAR[,c(2:18,25:27)])+I_AOM
P_TOTAL_H <- sum(COSTO_VAR[,c(19:24)])+P_AOM
SISTEMA_TOTAL_H <- I_TOTAL_H+P_TOTAL_H

#VOLÚMEN TRANSPORTADO SI EL SISTEMA FUERA ÓPTIMO
#SEGÚN ESTAMPILLA Y COSTO HISTÓRICO
VT_H_I <- I_TOTAL_H/round(ESTAMPILLA_INTERIOR,digits=4) #Interior
VT_H_P <- P_TOTAL_H/round(ESTAMPILLA_PROMIGAS,digits=4) #Costa
VT_H_S <- SISTEMA_TOTAL_H/round(ESTAMPILLA_SISTEMA,digits=4) #Sistema

#COSTO MOLÉCULA
CB_B_2021 <- as.numeric(VT_2021[1,-c(1:4)])*as.numeric(PrecioNodos[1,c(3:(184+2))])
CB_B_2022 <- as.numeric(VT_2022[1,-c(1:4)])*as.numeric(PrecioNodos[1,-c(1:(184+2))])
CostoM_Interior <- sum(CostoM_2021[2:20,])+sum(CostoM_2022[2:20,])+sum(CB_B_2021)+sum(CB_B_2022)
CostoM_Costa <- sum(CostoM_2021[-c(2:20),])+sum(CostoM_2022[-c(2:20),])-sum(CB_B_2021)-sum(CB_B_2022)
CostoM_Sistema <- CostoM_Interior+CostoM_Costa

REPORTE<-data.frame(Nombre=c("Costo de transporte del subsistema Interior (histórico) [$USD]",
                             "Costo de transporte del subsistema Costa (histórico) [$USD]",
                             "Costo de transporte del SNT (histórico) [$USD] ",
                             "Estampilla del subsistema Interior (histórico) [$USD/kPC]",
                             "Estampilla del subsistema Costa (histórico) [$USD/kPC]",
                             "Estampilla del SNT (histórico) [$USD/kPC] ",
                             "Volumen de gas transportado del subsistema Interior (histórico) [kPC]",
                             "Volumen de gas transportado del subsistema Costa (histórico) [kPC]",
                             "Volumen de gas transportado del SNT (histórico) [kPC] ",
                             "Costo de molécula (sin agregación de tramos) - Interior [$USD]",
                             "Costo de molécula (sin agregación de tramos) - Costa [$USD]",
                             "Costo de molécula (sin agregación de tramos) - Sistema [$USD]"),
                    Valor=c(I_TOTAL_H,P_TOTAL_H,SISTEMA_TOTAL_H,
                            ESTAMPILLA_INTERIOR,ESTAMPILLA_PROMIGAS,ESTAMPILLA_SISTEMA,
                            VT_H_I,VT_H_P,VT_H_S,
                            CostoM_Interior,CostoM_Costa,CostoM_Sistema
                            ))
write.xlsx(REPORTE, file = "REPORTE.xlsx")

